!
!  Interface definition modules for LU factorization.
!
MODULE LU

INTERFACE 

SUBROUTINE SGETRF_F90(A, IPIV, INFO)
   USE LA_PRECISION, ONLY:WP
   REAL(KIND=WP), INTENT(INOUT) :: A(:,:)
   INTEGER, INTENT(OUT)         :: IPIV(:)
   INTEGER, INTENT(OUT)         :: INFO
END SUBROUTINE SGETRF_F90

SUBROUTINE SGETF2_F90(A, IPIV, INFO)
   USE LA_PRECISION, ONLY:WP
   REAL(KIND=WP), INTENT(INOUT) :: A(:,:)
   INTEGER, INTENT(OUT)         :: IPIV(:)
   INTEGER, INTENT(OUT)         :: INFO
END SUBROUTINE SGETF2_F90

SUBROUTINE SLASWP_F90(A, K1, K2, IPIV, IDIR)
   USE LA_PRECISION, ONLY:WP
   REAL(KIND=WP), INTENT(INOUT) :: A(:,:)
   INTEGER,INTENT(IN)           :: K1, K2, IDIR
   INTEGER, INTENT(IN)          :: IPIV(:)
END SUBROUTINE SLASWP_F90

SUBROUTINE SGETRS_F90( TRANS, A, IPIV, B)
   USE LA_PRECISION, ONLY:WP
   CHARACTER*1                  :: TRANS
   REAL(KIND=WP), INTENT(IN)    :: A(:,:)
   INTEGER, INTENT(IN)          :: IPIV(:)
   REAL(KIND=WP), INTENT(INOUT) :: B(:,:)
END SUBROUTINE SGETRS_F90

SUBROUTINE STRTRI_F90( UPLO, DIAG, A, INFO )
   USE LA_PRECISION, ONLY:WP
   CHARACTER*1                  :: UPLO, DIAG
   REAL(KIND=WP), INTENT(INOUT) :: A(:,:)
   INTEGER, INTENT(OUT)         :: INFO
END SUBROUTINE STRTRI_F90

SUBROUTINE STRTI2_F90( UPLO, DIAG, A)
   USE LA_PRECISION, ONLY:WP
   CHARACTER*1                  :: UPLO, DIAG
   REAL(KIND=WP), INTENT(INOUT) :: A(:,:)
END SUBROUTINE STRTI2_F90

INTEGER FUNCTION ISAMAX_F90(X)
   USE LA_PRECISION, ONLY:WP
   REAL(KIND=WP), INTENT(IN)   :: X(:)
END FUNCTION ISAMAX_F90

SUBROUTINE SGETRI_F90(A, IPIV, INFO )
   USE LA_PRECISION, ONLY:WP
   REAL(KIND=WP), INTENT(INOUT) :: A(:,:)
   INTEGER, INTENT(IN)          :: IPIV(:)
   INTEGER, INTENT(OUT)         :: INFO
END SUBROUTINE SGETRI_F90

SUBROUTINE SGESV_F90(A, IPIV, B, INFO)
   USE LA_PRECISION, ONLY:WP
   REAL(KIND=WP), INTENT(INOUT) :: A(:,:), B(:,:)
   INTEGER, INTENT(OUT)         :: IPIV(:), INFO
END SUBROUTINE SGESV_F90

END INTERFACE

END MODULE LU
